DEFINE VARIABLE hDoc AS HANDLE NO-UNDO.
DEFINE VARIABLE hRoot AS HANDLE NO-UNDO.
DEFINE VARIABLE hRow AS HANDLE NO-UNDO.
DEFINE VARIABLE hField AS HANDLE NO-UNDO.
DEFINE VARIABLE hText AS HANDLE NO-UNDO.

DEFINE VARIABLE hDBFld AS HANDLE NO-UNDO.
DEFINE VARIABLE ix AS INTEGER NO-UNDO.
DEFINE VARIABLE hNoderef AS HANDLE NO-UNDO.

CREATE X-DOCUMENT hDoc.
CREATE X-NODEREF hRoot.
CREATE X-NODEREF hRow.
CREATE X-NODEREF hField.
CREATE X-NODEREF hText.
CREATE X-NODEREF hNoderef.

/* Set up a root node */
hDoc:CREATE-NODE(hRoot,"TestRoot","ELEMENT").
hDoc:APPEND-CHILD(hRoot).

DEFINE VARIABLE i AS INTEGER   NO-UNDO.

DO i = 1 to 5 BY 1:
 hDoc:CREATE-NODE(hRow,"TestBody","ELEMENT").
 /* create a row node */
  hRoot:APPEND-CHILD(hRow).
  hRow:GET-PARENT(hNoderef).
  Message "hRow_handle: " + STRING(hRow) + " parent_handle " +  STRING(hNoderef) + " actual_parent_handle " + STRING(hRoot).
  /* put the row in the tree */
  hRow:SET-ATTRIBUTE("SomeData", STRING(i)).
  hRow:SET-ATTRIBUTE("Name", "test").
  hRow:SET-ATTRIBUTE("Handle", STRING(hRow)).

  /* Add the other fields as tags in the xml */
  REPEAT ix = 1 TO 3 BY 1:

    /* Create a tag with the field name */
    hDoc:CREATE-NODE(hField, "name", "ELEMENT").

    /* Put the new field as next child of row */
    hRow:APPEND-CHILD(hField).

    hField:GET-PARENT(hNoderef).
    Message "hField_handle: " + STRING(hField) + " parent_handle " +  STRING(hNoderef) + " actual_parent_handle " + STRING(hRoot).

    hDoc:CREATE-NODE(hText, "", "TEXT").
    /* Attach the text to the field */
    hField:APPEND-CHILD(hText).
    /*Message "hText Handler: " + STRING(hText).*/
    hText:NODE-VALUE = "handle_" + STRING(hText).
  END.
END.

hDoc:GET-CHILD(hNoderef, 1).

/* Write the XML node tree to an xml file */
 hDoc:SAVE("file","test_xml.xml").

 DELETE OBJECT hDoc.
 DELETE OBJECT hRoot.
 DELETE OBJECT hRow.
 DELETE OBJECT hField.
 DELETE OBJECT hText.
